import javax.persistence.*;

public class Main {

    /* This program works both in Java SE as well as Java EE environment */
    @PersistenceUnit private static EntityManagerFactory emf;

    public static void main(String... args) throws Exception {
        if(emf == null) { // no injection => Java SE
            System.out.println("Defaulting to Java SE enviroment");
            emf = Persistence.createEntityManagerFactory("pu1", null);
        }
        EntityManager em = emf.createEntityManager();
        if(args.length == 0) {
            System.out.println("Usage: java "+ Main.class.getName() + " <name...>");
            System.exit(1);
        }
        for(String id : args) {
            EntityTransaction et = em.getTransaction();
            et.begin();
            System.out.println("*******Finding event " + id);
            EventPK eventPK = new EventPK(id, Event.class.getSimpleName());
	    Event event = em.find(Event.class, eventPK);
            if(event == null) {
                System.out.println("Creating event " + id);
                event = new Event();
                event.setNotificationId(id);
                em.persist(event);
            } else {
                System.out.println("Found event " + event.getNotificationId());
            }
            System.out.println("*******Finding alarm " + id);
            EventPK alarmPK = new EventPK(id, Alarm.class.getSimpleName());
	    Alarm alarm = em.find(Alarm.class, alarmPK);
            if(alarm == null) {
                System.out.println("Creating alarm " + id);
                alarm = new Alarm();
                alarm.setNotificationId(id);
                em.persist(alarm);
            } else {
                System.out.println("Found alarm " + alarm.getNotificationId());
            }
            et.commit();
        }
        em.close();
    }
}
